
-- FiresForever 2011 - "Procylon's Call to Power Project"

-------------------------------------------------
-- SocialPolicy Governements Page V1
-------------------------------------------------

include( "IconSupport" );
include( "InstanceManager" );
include( "TutorialPopupScreen" );

local m_PopupInfo = nil;
local PCat;

--Ideology Pages
-- fiscal policy
local g_ManoralismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.ManoralismPanel );
local g_FeudalismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.FeudalismPanel );
local g_MercantilismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.MercantilismPanel );
local g_LaissezFairePipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.LaissezFairePanel );
local g_CorporatismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.CorporatismPanel );

local g_CollectivismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.CollectivismPanel );
local g_CommandEconomyPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.CommandEconomyPanel );
local g_FreeTradePipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.FreeTradePanel );
local g_SocialismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.SocialismPanel );
local g_CommunismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.CommunismPanel );


local g_TraditionPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.TraditionPanel );
local g_NobilityPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.NobilityPanel );
local g_ImperialismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.ImperialismPanel );
local g_LibertarianismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.LibertarianismPanel );
local g_AnarchismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.AnarchismPanel );

local g_LibertyPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.LibertyPanel );
local g_FreedomPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.FreedomPanel );
local g_EnlightenmentPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.EnlightenmentPanel );
local g_TopDownPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.TopDownPanel );
local g_TotalControlPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.TotalControlPanel );


local g_ExpansionismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.ExpansionismPanel );
local g_HonorPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.HonorPanel );
local g_ColonialismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.ColonialismPanel );
local g_IsolationismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.IsolationismPanel );
local g_NationalismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.NationalismPanel );

local g_RestraintPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.RestraintPanel );
local g_SelfProtectionPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.SelfProtectionPanel );
local g_PacifismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.PacifismPanel );
local g_GlobalInvolvementPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.GlobalInvolvementPanel );
local g_TotalWarPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.TotalWarPanel );


local g_ScientificControlPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.ScientificControlPanel );
local g_PatronagePipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.PatronagePanel );
local g_StagnationPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.StagnationPanel );
local g_PersecutionPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.PersecutionPanel );
local g_ReligiousRightPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.ReligiousRightPanel );

local g_FreeResearchPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.FreeResearchPanel );
local g_KnowledgePipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.KnowledgePanel );
local g_RationalismPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.RationalismPanel );
local g_SponsorshipPipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.SponsorshipPanel );
local g_RadicalSciencePipeManager = InstanceManager:new( "ConnectorPipe", "ConnectorImage", Controls.RadicalSciencePanel );





local g_ManoralismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.ManoralismPanel );
local g_FeudalismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.FeudalismPanel );
local g_MercantilismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.MercantilismPanel );
local g_LaissezFaireInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.LaissezFairePanel );
local g_CorporatismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.CorporatismPanel );

local g_CollectivismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.CollectivismPanel );
local g_CommandEconomyInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.CommandEconomyPanel );
local g_FreeTradeInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.FreeTradePanel );
local g_SocialismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.SocialismPanel );
local g_CommunismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.CommunismPanel );


local g_TraditionInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.TraditionPanel );
local g_NobilityInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.NobilityPanel );
local g_ImperialismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.ImperialismPanel );
local g_LibertarianismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.LibertarianismPanel );
local g_AnarchismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.AnarchismPanel );

local g_LibertyInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.LibertyPanel );
local g_FreedomInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.FreedomPanel );
local g_EnlightenmentInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.EnlightenmentPanel );
local g_TopDownInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.TopDownPanel );
local g_TotalControlInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.TotalControlPanel );


local g_ExpansionismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.ExpansionismPanel );
local g_HonorInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.HonorPanel );
local g_ColonialismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.ColonialismPanel );
local g_IsolationismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.IsolationismPanel );
local g_NationalismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.NationalismPanel );

local g_RestraintInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.RestraintPanel );
local g_SelfProtectionInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.SelfProtectionPanel );
local g_PacifismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.PacifismPanel );
local g_GlobalInvolvementInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.GlobalInvolvementPanel );
local g_TotalWarInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.TotalWarPanel );


local g_ScientificControlInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.ScientificControlPanel );
local g_PatronageInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.PatronagePanel );
local g_StagnationInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.StagnationPanel );
local g_PersecutionInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.PersecutionPanel );
local g_ReligiousRightInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.ReligiousRightPanel );

local g_FreeResearchInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.FreeResearchPanel );
local g_KnowledgeInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.KnowledgePanel );
local g_RationalismInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.RationalismPanel );
local g_SponsorshipInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.SponsorshipPanel );
local g_RadicalScienceInstanceManager = InstanceManager:new( "PolicyButton", "PolicyIcon", Controls.RadicalSciencePanel );


include( "FLuaVector" );

local fullColor = {x = 1, y = 1, z = 1, w = 1};
local fadeColor = {x = 1, y = 1, z = 1, w = 0};
local fadeColorRV = {x = 1, y = 1, z = 1, w = 0.2};
local pinkColor = {x = 2, y = 0, z = 2, w = 1};
local lockTexture = "48Lock.dds";
local checkTexture = "48Checked.dds";

local hTexture = "Connect_H.dds";
local vTexture = "Connect_V.dds";

local topRightTexture =		"Connect_JonCurve_TopRight.dds"
local topLeftTexture =		"Connect_JonCurve_TopLeft.dds"
local bottomRightTexture =	"Connect_JonCurve_BottomRight.dds"
local bottomLeftTexture =	"Connect_JonCurve_BottomLeft.dds"

local policyIcons = {};

local g_PolicyXOffset = 28;
local g_PolicyYOffset = 68;

local g_PolicyPipeXOffset = 28;
local g_PolicyPipeYOffset = 68;

local m_gPolicyID;
local m_gAdoptingPolicy;

local numBranchesRequiredForUtopia = GameInfo.Projects["PROJECT_UTOPIA_PROJECT"].CultureBranchesRequired;

-----------------------------------------------
-- Ideology or Regular Policy?
-----------------------------------------------

function isPolicyBranchIdeology( iPlayer, politicalIdeology )
	local isIdeology = GameInfo.PolicyBranchTypes[politicalIdeology].IsIdeology
	if isIdeology then
		bob = true
	endif
	bob = false
end
		
function cannotAdoptIdeology ( iPlayer, bob )
	if bob then
		return false
	endif
	return true
end

GameEvents.PlayerCanAdoptPolicyBranch.Add(OnCanAdoptPolicyBranch)
	
-------------------------------------------------
-- On Policy Selected
-------------------------------------------------
function PolicySelected( policyIndex )
    
    print("Clicked on Policy: " .. tostring(policyIndex));
    
	if policyIndex == -1 then
		return;
	end
    local player = Players[Game.GetActivePlayer()];   
    if player == nil then
		return;
    end
    
    local bHasPolicy = player:HasPolicy(policyIndex);
    local bCanAdoptPolicy = player:CanAdoptPolicy(policyIndex);
    
    print("bHasPolicy: " .. tostring(bHasPolicy));
    print("bCanAdoptPolicy: " .. tostring(bCanAdoptPolicy));
    print("Policy Blocked: " .. tostring(player:IsPolicyBlocked(policyIndex)));
    
    local bPolicyBlocked = false;
    
    -- If we can get this, OR we already have it, see if we can unblock it first
    if (bHasPolicy or bCanAdoptPolicy) then
    
		-- Policy blocked off right now? If so, try to activate
		if (player:IsPolicyBlocked(policyIndex)) then

			bPolicyBlocked = true;

			local strPolicyBranch = GameInfo.Policies[policyIndex].PolicyBranchType;
			local iPolicyBranch = GameInfoTypes[strPolicyBranch];

			print("Policy Branch: " .. tostring(iPolicyBranch));

			local popupInfo = {
				Type = ButtonPopupTypes.BUTTONPOPUP_CONFIRM_POLICY_BRANCH_SWITCH,
				Data1 = iPolicyBranch;
			}
			Events.SerialEventGameMessagePopup(popupInfo);

		end
    end
    
    -- Can adopt Policy right now - don't try this if we're going to unblock the Policy instead
    if (bCanAdoptPolicy and not bPolicyBlocked) then
		m_gPolicyID = policyIndex;
		m_gAdoptingPolicy = true;
		Controls.PolicyConfirm:SetHide(false);
		Controls.BGBlock:SetHide(true);
		--Network.SendUpdatePolicies(policyIndex, true, true);
		--Events.AudioPlay2DSound("AS2D_INTERFACE_POLICY");		
	end

end

-------------------------------------------------
-- On Policy Branch Selected
-------------------------------------------------
function PolicyBranchSelected( policyBranchIndex )
    
    print("Clicked on PolicyBranch: " .. tostring(policyBranchIndex));
    
	if policyBranchIndex == -1 then
		return;
	end
    local player = Players[Game.GetActivePlayer()];   
    if player == nil then
		return;
    end
    
    local bHasPolicyBranch = player:IsPolicyBranchUnlocked(policyBranchIndex);
    local bCanAdoptPolicyBranch = player:CanUnlockPolicyBranch(policyBranchIndex);
    
    --print("bHasPolicyBranch: " .. tostring(bHasPolicyBranch));
    --print("bCanAdoptPolicyBranch: " .. tostring(bCanAdoptPolicyBranch));
   -- print("PolicyBranch Blocked: " .. tostring(player:IsPolicyBranchBlocked(policyBranchIndex)));
    
    local bUnblockingPolicyBranch = false;
    
    -- If we can get this, OR we already have it, see if we can unblock it first
    if (bHasPolicyBranch or bCanAdoptPolicyBranch) then
    
		-- Policy Branch blocked off right now? If so, try to activate
		if (player:IsPolicyBranchBlocked(policyBranchIndex)) then

			bUnblockingPolicyBranch = true;

			local popupInfo = {
				Type = ButtonPopupTypes.BUTTONPOPUP_CONFIRM_POLICY_BRANCH_SWITCH,
				Data1 = policyBranchIndex;
			}
			Events.SerialEventGameMessagePopup(popupInfo);
		end
    end
    
    -- Can adopt Policy Branch right now - don't try this if we're going to unblock the Policy Branch instead
    if (bCanAdoptPolicyBranch and not bUnblockingPolicyBranch) then
		m_gPolicyID = policyBranchIndex;
		m_gAdoptingPolicy = false;
		Controls.PolicyConfirm:SetHide(false);
		Controls.BGBlock:SetHide(true);
	end

	---- Are we allowed to unlock this Branch right now?
	--if player:CanUnlockPolicyBranch( policyBranchIndex ) then
		--
		---- Can't adopt the Policy Branch - can we switch active branches though?
		--if (player:IsPolicyBranchBlocked(policyBranchIndex)) then
		--
			--local popupInfo = {
				--Type = ButtonPopupTypes.BUTTONPOPUP_CONFIRM_POLICY_BRANCH_SWITCH,
				--Data1 = policyBranchIndex;
			--}
			--Events.SerialEventGameMessagePopup(popupInfo);
	    --
		---- Can adopt this Policy Branch right now
		--else
			--Network.SendUpdatePolicies(policyBranchIndex, false, true);
		--end
	--end
end

-------------------------------------------------
-------------------------------------------------
function OnPopupMessage(popupInfo)

	local popupType = popupInfo.Type;
	if popupType ~= ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY then
		return;
	end

	m_PopupInfo = popupInfo;

	PCat = "POLICYTREECAT_GOVERNMENTS";
	UpdateDisplay();

	if( m_PopupInfo.Data1 == 1 ) then
    	if( ContextPtr:IsHidden() == false ) then
    	    OnClose();
    	else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.eUtmost );
    	end
	else
    	UIManager:QueuePopup( ContextPtr, PopupPriority.SocialPolicy );
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopupMessage );

-------------------------------------------------
-------------------------------------------------
function UpdateDisplay()

    
	local player = Players[Game.GetActivePlayer()];
    local pTeam = Teams[player:GetTeam()];
    
    if player == nil then
		return;
    end
    
	local playerHas1City = player:GetNumCities() > 0;
    Controls.AnarchyBlock:SetHide( not player:IsAnarchy() );

    local bShowAll = OptionsManager.GetPolicyInfo();
    
    local szText = Locale.ConvertTextKey("TXT_KEY_NEXT_POLICY_COST_LABEL", player:GetNextPolicyCost());
    Controls.NextCost:SetText(szText);
    
    szText = Locale.ConvertTextKey("TXT_KEY_CURRENT_CULTURE_LABEL", player:GetJONSCulture());
    Controls.CurrentCultureLabel:SetText(szText);
    
    szText = Locale.ConvertTextKey("TXT_KEY_CULTURE_PER_TURN_LABEL", player:GetTotalJONSCulturePerTurn());
    Controls.CulturePerTurnLabel:SetText(szText);
    
    local iTurns;
    local iCultureNeeded = player:GetNextPolicyCost() - player:GetJONSCulture();
    if (iCultureNeeded <= 0) then
		iTurns = 0;
    else
		if (player:GetTotalJONSCulturePerTurn() == 0) then
			iTurns = "?";
		else
			iTurns = iCultureNeeded / player:GetTotalJONSCulturePerTurn();
			iTurns = iTurns + 1;
			iTurns = math.floor(iTurns);
		end
    end
    szText = Locale.ConvertTextKey("TXT_KEY_NEXT_POLICY_TURN_LABEL", iTurns);
    Controls.NextPolicyTurnLabel:SetText(szText);
    
    -- Player Title
    local iDominantBranch = player:GetDominantPolicyBranchForTitle();
    if (iDominantBranch ~= -1) then

		local strTextKey = GameInfo.PolicyBranchTypes[iDominantBranch].Title;

		local strText = Locale.ConvertTextKey(strTextKey, player:GetNameKey(), player:GetCivilizationShortDescriptionKey());

	    Controls.PlayerTitleLabel:SetHide(false);
	    Controls.PlayerTitleLabel:SetText(strText);
	else
	    Controls.PlayerTitleLabel:SetHide(true);
    end
    
    -- Free Policies
    local iNumFreePolicies = player:GetNumFreePolicies();
    if (iNumFreePolicies > 0) then
	    szText = Locale.ConvertTextKey("TXT_KEY_FREE_POLICIES_LABEL", iNumFreePolicies);
	    Controls.FreePoliciesLabel:SetText( szText );
	    Controls.FreePoliciesLabel:SetHide( false );
	else
	    Controls.FreePoliciesLabel:SetHide( true );
    end
    
	Controls.InfoStack:ReprocessAnchoring();
    
	--szText = Locale.ConvertTextKey( "TXT_KEY_SOCIAL_POLICY_DIRECTIONS" );
    --Controls.ReminderText:SetText( szText );

	local justLooking = true;
	if player:GetJONSCulture() >= player:GetNextPolicyCost() then
		justLooking = false;
	end

	-- Adjust Policy Branches
	local i = 0;
	local id
	local numUnlockedBranches = player:GetNumPolicyBranchesUnlocked();
--	if numUnlockedBranches > 0 then
		local policyBranchInfo;

		for policyBranchInfo in DB.Query("SELECT * FROM PolicyBranchTypes") do	
		id = policyBranchInfo.ID
		if policyBranchInfo ~= nil then
			if policyBranchInfo.PolicyCat == PCat then
			local numString = tostring( id );

			--print("Clicked on PolicyBranch: " ..numString);

			local buttonName = "BranchButton"..numString;
			local backName = "BranchBack"..numString;
			local DisabledBoxName = "DisabledBox"..numString;
			local LockedBoxName = "LockedBox"..numString;
			local ImageMaskName = "ImageMask"..numString;
			local DisabledMaskName = "DisabledMask"..numString;
			--local EraLabelName = "EraLabel"..numString;

			local thisButton = Controls[buttonName];
			local thisBack = Controls[backName];
			local thisDisabledBox = Controls[DisabledBoxName];
			local thisLockedBox = Controls[LockedBoxName];

			local thisImageMask = Controls[ImageMaskName];
			local thisDisabledMask = Controls[DisabledMaskName];


			if(thisImageMask == nil) then
				print(ImageMaskName);
			end
			--local thisEraLabel = Controls[EraLabelName];

			local strToolTip = Locale.ConvertTextKey(policyBranchInfo.Help);

			-- Era Prereq
			local iEraPrereq = GameInfoTypes[policyBranchInfo.EraPrereq]
			local bEraLock = false;
			if (iEraPrereq ~= nil and pTeam:GetCurrentEra() < iEraPrereq) then
				bEraLock = true;
			else
				--thisEraLabel:SetHide(true);
			end

			local lockName = "Lock"..numString;
			local thisLock = Controls[lockName];

			-- Branch is not yet unlocked
			if not player:IsPolicyBranchUnlocked( id ) then

				-- Cannot adopt this branch right now
				if (not player:CanUnlockPolicyBranch(id)) then

					strToolTip = strToolTip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_POLICY_BRANCH_CANNOT_UNLOCK");

					-- Not in prereq Era
					if (bEraLock) then
						local strEra = GameInfo.Eras[iEraPrereq].Description;
						strToolTip = strToolTip .. " " .. Locale.ConvertTextKey("TXT_KEY_POLICY_BRANCH_CANNOT_UNLOCK_ERA", strEra);

						-- Era Label
						--local strEraTitle = "[COLOR_WARNING_TEXT]" .. Locale.ConvertTextKey(strEra) .. "[ENDCOLOR]";
						local strEraTitle = Locale.ConvertTextKey(strEra);
						thisButton:SetText( strEraTitle );
						--thisEraLabel:SetText(strEraTitle);
						--thisEraLabel:SetHide( true );

						--thisButton:SetHide( true );

					-- Don't have enough Culture Yet
					else
						strToolTip = strToolTip .. " " .. Locale.ConvertTextKey("TXT_KEY_POLICY_BRANCH_CANNOT_UNLOCK_CULTURE", player:GetNextPolicyCost());
						thisButton:SetHide( false );
						thisButton:SetText( Locale.ConvertTextKey( "TXT_KEY_POP_ADOPT_BUTTON" ) );
						--thisEraLabel:SetHide( true );
					end

					thisLock:SetHide( false );
					thisButton:SetDisabled( true );
				-- Can adopt this branch right now
				else
					strToolTip = strToolTip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_POLICY_BRANCH_UNLOCK_SPEND", player:GetNextPolicyCost());
					thisLock:SetHide( true );
					--thisEraLabel:SetHide( true );
					thisButton:SetDisabled( false );
					thisButton:SetHide( false );
					thisButton:SetText( Locale.ConvertTextKey( "TXT_KEY_POP_ADOPT_BUTTON" ) );
				end

				if(not playerHas1City) then
					thisButton:SetDisabled(true);
				end
				thisBack:SetColor( fadeColor );
				thisLockedBox:SetHide(false);


				thisImageMask:SetHide(true);
				thisDisabledMask:SetHide(false);

			-- Branch is unlocked, but blocked by another branch
			elseif (player:IsPolicyBranchBlocked(i)) then
				thisButton:SetHide( false );
				thisBack:SetColor( fadeColor );
				thisLock:SetHide( false );
				thisLockedBox:SetHide(true);

				strToolTip = strToolTip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_POLICY_BRANCH_BLOCKED");

			-- Branch is unlocked already
			else
				thisButton:SetHide( true );
				thisBack:SetColor( fullColor );
				thisLockedBox:SetHide(true);
				thisImageMask:SetHide(false);
				thisDisabledMask:SetHide(true);
			end

			-- Update tooltips
			thisButton:SetToolTipString(strToolTip);

			-- If the player doesn't have the era prereq, then dim out the branch
			if (bEraLock) then
				thisDisabledBox:SetHide(false);
				thisLockedBox:SetHide(true);
			else
				thisDisabledBox:SetHide(true);
			end

			if (bShowAll) then
				thisDisabledBox:SetHide(true);
				thisLockedBox:SetHide(true);
			end
			i = i + 1;
		end

		end
			--i = i + 1;
			--policyBranchInfo = GameInfo.PolicyBranchTypes[i];
		end
	--else
		--local policyBranchInfo = GameInfo.PolicyBranchTypes[i];
		--while policyBranchInfo ~= nil do
			--local numString = tostring(i);
			--local buttonName = "BranchButton"..numString;
			--local backName = "BranchBack"..numString;
			--local thisButton = Controls[buttonName];
			--local thisBack = Controls[backName];
			--thisBack:SetColor( fullColor );
			--thisButton:SetHide( true );
			--i = i + 1;
			--policyBranchInfo = GameInfo.PolicyBranchTypes[i];
		--end
	--end

	-- Adjust Policy buttons
	i = 0;
	local policyInfo = GameInfo.Policies[i];

	for policyInfo in DB.Query("SELECT * FROM Policies") do	

	if policyInfo ~= nil then

		local iBranch = policyInfo.PolicyBranchType;

		-- If this is nil it means the Policy is a freebie handed out with the Branch, so don't display it
		if (iBranch ~= nil) then
			local thisPolicyIcon = policyIcons[i];

			-- Tooltip
			local strTooltip = Locale.ConvertTextKey( policyInfo.Help );

			-- Player already has Policy
			if player:HasPolicy( i ) then
				--thisPolicyIcon.Lock:SetTexture( checkTexture ); 
				--thisPolicyIcon.Lock:SetHide( true ); 
				thisPolicyIcon.MouseOverContainer:SetHide( true );
				thisPolicyIcon.PolicyIcon:SetDisabled( true );
				--thisPolicyIcon.PolicyIcon:SetVoid1( -1 );
				thisPolicyIcon.PolicyImage:SetColor( fullColor );
				IconHookup( policyInfo.PortraitIndex, 64, policyInfo.IconAtlasAchieved, thisPolicyIcon.PolicyImage );
			elseif(not playerHas1City) then
				--thisPolicyIcon.Lock:SetTexture( lockTexture ); 
				thisPolicyIcon.MouseOverContainer:SetHide( true );
				--thisPolicyIcon.Lock:SetHide( true ); 
				thisPolicyIcon.PolicyIcon:SetDisabled( true );
				--thisPolicyIcon.Lock:SetHide( false ); 
				--thisPolicyIcon.PolicyIcon:SetVoid1( -1 );
				thisPolicyIcon.PolicyImage:SetColor( fadeColorRV );
				IconHookup( policyInfo.PortraitIndex, 64, policyInfo.IconAtlas, thisPolicyIcon.PolicyImage );
				-- Tooltip
				strTooltip = strTooltip .. "[NEWLINE][NEWLINE]"

			-- Can adopt the Policy right now
			elseif player:CanAdoptPolicy( i ) then
				--thisPolicyIcon.Lock:SetHide( true ); 
				thisPolicyIcon.MouseOverContainer:SetHide( false );
				thisPolicyIcon.PolicyIcon:SetDisabled( false );
				if justLooking then
					--thisPolicyIcon.PolicyIcon:SetVoid1( -1 );
					thisPolicyIcon.PolicyImage:SetColor( fullColor );
				else
					thisPolicyIcon.PolicyIcon:SetVoid1( i ); -- indicates policy to be chosen
					thisPolicyIcon.PolicyImage:SetColor( fullColor );
				end
				IconHookup( policyInfo.PortraitIndex, 64, policyInfo.IconAtlas, thisPolicyIcon.PolicyImage );

			-- Policy is locked
			else
				--thisPolicyIcon.Lock:SetTexture( lockTexture ); 
				thisPolicyIcon.MouseOverContainer:SetHide( true );
				--thisPolicyIcon.Lock:SetHide( true ); 
				thisPolicyIcon.PolicyIcon:SetDisabled( true );
				--thisPolicyIcon.Lock:SetHide( false ); 
				--thisPolicyIcon.PolicyIcon:SetVoid1( -1 );
				thisPolicyIcon.PolicyImage:SetColor( fadeColorRV );
				IconHookup( policyInfo.PortraitIndex, 64, policyInfo.IconAtlas, thisPolicyIcon.PolicyImage );
				-- Tooltip
				strTooltip = strTooltip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_POLICY_CANNOT_UNLOCK");
			end

			-- Policy is Blocked
			if player:IsPolicyBlocked(i) then
				thisPolicyIcon.PolicyImage:SetColor( fadeColorRV );
				IconHookup( policyInfo.PortraitIndex, 64, policyInfo.IconAtlas, thisPolicyIcon.PolicyImage );

				-- Update tooltip if we have this Policy
				if player:HasPolicy( i ) then
					strTooltip = strTooltip .. "[NEWLINE][NEWLINE]" .. Locale.ConvertTextKey("TXT_KEY_POLICY_BRANCH_BLOCKED");
				end
			end

			thisPolicyIcon.PolicyIcon:SetToolTipString( strTooltip );
		end
	end
		i = i + 1;
		--policyInfo = GameInfo.Policies[i];
	end

	-- update the Utopia bar
	local numDone = player:GetNumPolicyBranchesFinished();
	local percentDone = numDone / numBranchesRequiredForUtopia;
	if percentDone > 1 then
		percentDone = 1;
	end
	Controls.UtopiaBar:SetPercent( percentDone );
end
Events.EventPoliciesDirty.Add( UpdateDisplay );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose()
	UIManager:DequeuePopup( ContextPtr );
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose );

----------------------------------------------------------------
-- Checkboxes to switch Policy-views.
----------------------------------------------------------------
function OnGovs( )

	Controls.GovernmentsSelectHighlight:SetHide(false);
	Controls.GovernmentIdeSelectHighlight:SetHide(true);
	Controls.GovernmentSysSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.TopGovernmentsStack:SetHide( false );
	Controls.BottomGovernmentsStack:SetHide( false );
	Controls.TopGovernmentIdeStack:SetHide( true );
	Controls.BottomGovernmentIdeStack:SetHide( true );
	Controls.TopGovernmentSysStack:SetHide( true );
	Controls.BottomGovernmentSysStack:SetHide( true );

	--Show the correct Title and hide the rest
	--Controls.GovernmentsTitle:SetHide( false );
	--Controls.GovernmentIdeTitle:SetHide( true );
	--Controls.GovernmentSysTitle:SetHide( true );


end
Controls.GovernmentsInfo:RegisterCallback( Mouse.eLClick, OnGovs );


function OnGovsIde( )

	Controls.GovernmentsSelectHighlight:SetHide(true);
	Controls.GovernmentIdeSelectHighlight:SetHide(false);
	Controls.GovernmentSysSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.TopGovernmentsStack:SetHide( true );	
	Controls.BottomGovernmentsStack:SetHide( true );
	Controls.TopGovernmentIdeStack:SetHide( false );
	Controls.BottomGovernmentIdeStack:SetHide( false );
	Controls.TopGovernmentSysStack:SetHide( true );
	Controls.BottomGovernmentSysStack:SetHide( true );

	--Show the correct Title and hide the rest
	--Controls.GovernmentsTitle:SetHide( true );
	--Controls.GovernmentIdeTitle:SetHide( false );
	--Controls.GovernmentSysTitle:SetHide( true );

end
Controls.GovernmentIdeologyInfo:RegisterCallback( Mouse.eLClick, OnGovsIde );

function OnGovsSys( )

	Controls.GovernmentsSelectHighlight:SetHide(true);
	Controls.GovernmentIdeSelectHighlight:SetHide(true);
	Controls.GovernmentSysSelectHighlight:SetHide(false);

	-- Show the selected policies and hide the rest
	Controls.TopGovernmentsStack:SetHide( true );	
	Controls.BottomGovernmentsStack:SetHide( true );
	Controls.TopGovernmentIdeStack:SetHide( true );
	Controls.BottomGovernmentIdeStack:SetHide( true );
	Controls.TopGovernmentSysStack:SetHide( false );
	Controls.BottomGovernmentSysStack:SetHide( false );

	--Show the correct Title and hide the rest
	--Controls.GovernmentsTitle:SetHide( true );
	--Controls.GovernmentIdeTitle:SetHide( true );
	--Controls.GovernmentSysTitle:SetHide( false );

end
Controls.GovernmentSysInfo:RegisterCallback( Mouse.eLClick, OnGovsSys );

----------------------------------------------------------------
----------------------------------------------------------------
function OnPolicyInfo( bIsChecked )
	local bUpdateScreen = false;

	if (bIsChecked ~= OptionsManager.GetPolicyInfo()) then
		bUpdateScreen = true;
	end

    OptionsManager.SetPolicyInfo_Cached( bIsChecked );
    OptionsManager.CommitGameOptions();
    
    if (bUpdateScreen) then
		Events.EventPoliciesDirty();
	end
end
Controls.PolicyInfo:RegisterCheckHandler( OnPolicyInfo );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    ----------------------------------------------------------------        
    -- Key Down Processing
    ----------------------------------------------------------------        
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
			if(Controls.PolicyConfirm:IsHidden())then
	            OnClose();
	        else
				Controls.PolicyConfirm:SetHide(true);
            	Controls.BGBlock:SetHide(false);
			end
			return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );

function GetPipe(branchType)
	local controlTable = nil;
	-- decide which panel it goes on
	if branchType == "POLICY_BRANCH_MANORALISM" then
		controlTable = g_ManoralismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_FEUDALISM" then
		contralTable = g_FeudalismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_MERCANTILISM" then
		contralTable = g_MercantilismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_LAISSEZ_FAIRE" then
		contralTable = g_LaissezFairePipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_CORPORATISM" then
		contralTable = g_CorporatismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_COLLECTIVISM" then
		contralTable = g_CollectivismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_COMMAND_ECONOMY" then
		contralTable = g_CommandEconomyPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_FREE_TRADE" then
		contralTable = g_FreeTradePipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_SOCIALISM" then
		contralTable = g_SocialismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_COMMUNISM" then
		contralTable = g_CommunismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_TRADITION" then
		contralTable = g_TraditionPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_NOBILITY" then
		contralTable = g_NobilityPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_IMPERIALISM" then
		contralTable = g_ImperialismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_LIBERTARIANISM" then
		contralTable = g_LibertarianismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_ANARCHY" then
		contralTable = g_AnarchismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_LIBERTY" then
		contralTable = g_LibertyPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_FREEDOM" then
		contralTable = g_FreedomPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_ENLIGHTENMENT" then
		contralTable = g_EnlightenmentPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_TOP_DOWN_CONTROL" then
		contralTable = g_TopDownPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_DYSTOPIA" then
		contralTable = g_DystopiaPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_EXPANSIONISM" then
		contralTable = g_ExpansionismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_HONOR" then
		contralTable = g_HonorPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_COLONIALISM" then
		contralTable = g_ColonialismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_ISOLATIONISM" then
		contralTable = g_IsolationismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_NATIONALISM" then
		contralTable = g_NationalismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_RESTRAINT" then
		contralTable = g_RestraintPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_SELF_PROTECTION" then
		contralTable = g_SelfProtectionPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_PACIFISM" then
		contralTable = g_PacifismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_GLOBAL_INVOLVEMENT" then
		contralTable = g_GlobalInvolvementPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_TOTAL_WAR" then
		contralTable = g_TotalWarPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_SCIENTIFIC_CONTROL" then
		contralTable = g_ScientificControlPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_PATRONAGE" then
		contralTable = g_PatronagePipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_STAGNATION" then
		contralTable = g_StagnationPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_PERSECUTION" then
		contralTable = g_PersecutionPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_RELIGIOUS_RIGHT" then
		contralTable = g_ReligousRightPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_FREE_RESEARCH" then
		contralTable = g_FreeResearchPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_KNOWLEDGE" then
		contralTable = g_KnowledgePipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_RATIONALISM" then
		contralTable = g_RationalismPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_SPONSORSHIP" then
		contralTable = g_SponsorshipPipeManager:GetInstance();
	elseif branchType == "POLICY_BRANCH_RADICAL_SCIENCE" then
		contralTable = g_RadicalSciencePipeManager:GetInstance();
	return controlTable;
	end
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function Init()

	PCat = "POLICYTREECAT_GOVERNMENTS";
	-- Activate the Branch buttons
	local i = 0;
	local id;
	local policyBranchInfo;
	for policyBranchInfo in DB.Query("SELECT * FROM PolicyBranchTypes") do	
			if policyBranchInfo.PolicyCat == PCat then
				id = policyBranchInfo.ID
				local buttonName = "BranchButton"..tostring( id );
				local thisButton = Controls[buttonName];
				thisButton:SetVoid1( id ); -- indicates type
				thisButton:RegisterCallback( Mouse.eLClick, PolicyBranchSelected );
				i = i + 1;
			end

			--i = i + 1;
			--policyBranchInfo = GameInfo.PolicyBranchTypes[i];
	end


	addpipes ()
	addbuttons ()
end


function addpipes()
	-- add the pipes
	local policyPipes = {};
	for row in GameInfo.Policies() do
		policyPipes[row.Type] = 
		{
			upConnectionLeft = false;
			upConnectionRight = false;
			upConnectionCenter = false;
			upConnectionType = 0;
			downConnectionLeft = false;
			downConnectionRight = false;
			downConnectionCenter = false;
			downConnectionType = 0;
			yOffset = 0;
			policyType = row.Type;
		};
	end

	local cnxCenter = 1
	local cnxLeft = 2
	local cnxRight = 4

	-- Figure out which top and bottom adapters we need
	for row in GameInfo.Policy_PrereqPolicies() do

		local prereq = GameInfo.Policies[row.PrereqPolicy];
		local policy = GameInfo.Policies[row.PolicyType];
		if (prereq ~= nil) then

			if policy and prereq then
				if policy.GridX < prereq.GridX then
					policyPipes[policy.Type].upConnectionRight = true;
					policyPipes[prereq.Type].downConnectionLeft = true;
				elseif policy.GridX > prereq.GridX then
					policyPipes[policy.Type].upConnectionLeft = true;
					policyPipes[prereq.Type].downConnectionRight = true;
				else -- policy.GridX == prereq.GridX
					policyPipes[policy.Type].upConnectionCenter = true;
					policyPipes[prereq.Type].downConnectionCenter = true;
				end
				local yOffset = (policy.GridY - prereq.GridY) - 1;
				if yOffset > policyPipes[prereq.Type].yOffset then
					policyPipes[prereq.Type].yOffset = yOffset;
				end
			end

		end
	end

	for pipeIndex, thisPipe in pairs(policyPipes) do
		if thisPipe.upConnectionLeft then
			thisPipe.upConnectionType = thisPipe.upConnectionType + cnxLeft;
		end 
		if thisPipe.upConnectionRight then
			thisPipe.upConnectionType = thisPipe.upConnectionType + cnxRight;
		end 
		if thisPipe.upConnectionCenter then
			thisPipe.upConnectionType = thisPipe.upConnectionType + cnxCenter;
		end 
		if thisPipe.downConnectionLeft then
			thisPipe.downConnectionType = thisPipe.downConnectionType + cnxLeft;
		end 
		if thisPipe.downConnectionRight then
			thisPipe.downConnectionType = thisPipe.downConnectionType + cnxRight;
		end 
		if thisPipe.downConnectionCenter then
			thisPipe.downConnectionType = thisPipe.downConnectionType + cnxCenter;
		end 
	end

	-- three passes down, up, connection
	-- connection
	for row in GameInfo.Policy_PrereqPolicies() do
		local prereq = GameInfo.Policies[row.PrereqPolicy];
		local policy = GameInfo.Policies[row.PolicyType];
		if (prereq ~= nil) then
		if policy and prereq then

			local thisPipe = policyPipes[row.PrereqPolicy];

			if policy.GridY - prereq.GridY > 1 or policy.GridY - prereq.GridY < -1 then
				local xOffset = (prereq.GridX-1)*g_PolicyPipeXOffset + 30;
				local pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset, (prereq.GridY-1)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(vTexture);
				local size = { x = 19; y = g_PolicyPipeYOffset*(policy.GridY - prereq.GridY - 1); };
				pipe.ConnectorImage:SetSize(size);
			end

			if policy.GridX - prereq.GridX == 1 then
				local xOffset = (prereq.GridX-1)*g_PolicyPipeXOffset + 30;
				local pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset + 16, (prereq.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(hTexture);
				local size = { x = 19; y = 19; };
				pipe.ConnectorImage:SetSize(size);
			end
			if policy.GridX - prereq.GridX == 2 then
				local xOffset = (prereq.GridX-1)*g_PolicyPipeXOffset + 30;
				local pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset + 16, (prereq.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(hTexture);
				local size = { x = 40; y = 19; };
				pipe.ConnectorImage:SetSize(size);
			end
			if policy.GridX - prereq.GridX == -2 then
				local xOffset = (policy.GridX-1)*g_PolicyPipeXOffset + 30;
				local pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset + 16, (prereq.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(hTexture);
				local size = { x = 40; y = 19; };
				pipe.ConnectorImage:SetSize(size);
			end
			if policy.GridX - prereq.GridX == -1 then
				local xOffset = (policy.GridX-1)*g_PolicyPipeXOffset + 30;
				local pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset + 16, (prereq.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(hTexture);
				local size = { x = 20; y = 19; };
				pipe.ConnectorImage:SetSize(size);
			end
		end
		end
	end

	-- Down	
	for pipeIndex, thisPipe in pairs(policyPipes) do
		local policy = GameInfo.Policies[thisPipe.policyType];
		local xOffset = (policy.GridX-1)*g_PolicyPipeXOffset + 30;
		if thisPipe.downConnectionType >= 1 then

			local startPipe = GetPipe(policy.PolicyBranchType);
			startPipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 48 );
			startPipe.ConnectorImage:SetTexture(vTexture);

			local pipe = GetPipe(policy.PolicyBranchType);			
			if thisPipe.downConnectionType == 1 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(vTexture);
			elseif thisPipe.downConnectionType == 2 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomRightTexture);
			elseif thisPipe.downConnectionType == 3 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(vTexture);
				pipe = GetPipe(policy.PolicyBranchType);			
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomRightTexture);
			elseif thisPipe.downConnectionType == 4 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomLeftTexture);
			elseif thisPipe.downConnectionType == 5 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(vTexture);
				pipe = GetPipe(policy.PolicyBranchType);			
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomLeftTexture);
			elseif thisPipe.downConnectionType == 6 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomRightTexture);
				pipe = GetPipe(policy.PolicyBranchType);		
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomLeftTexture);
			else
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(vTexture);
				pipe = GetPipe(policy.PolicyBranchType);		
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomRightTexture);
				pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1 + thisPipe.yOffset)*g_PolicyPipeYOffset + 58 );
				pipe.ConnectorImage:SetTexture(bottomLeftTexture);
			end
		end
	end

	-- Up
	for pipeIndex, thisPipe in pairs(policyPipes) do
		local policy = GameInfo.Policies[thisPipe.policyType];
		local xOffset = (policy.GridX-1)*g_PolicyPipeXOffset + 30;

		if thisPipe.upConnectionType >= 1 then

			local startPipe = GetPipe(policy.PolicyBranchType);
			startPipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset + 0 );
			startPipe.ConnectorImage:SetTexture(vTexture);

			local pipe = GetPipe(policy.PolicyBranchType);			
			if thisPipe.upConnectionType == 1 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(vTexture);
			elseif thisPipe.upConnectionType == 2 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topRightTexture);
			elseif thisPipe.upConnectionType == 3 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(vTexture);
				pipe = GetPipe(policy.PolicyBranchType);			
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topRightTexture);
			elseif thisPipe.upConnectionType == 4 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topLeftTexture);
			elseif thisPipe.upConnectionType == 5 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(vTexture);
				pipe = GetPipe(policy.PolicyBranchType);			
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topLeftTexture);
			elseif thisPipe.upConnectionType == 6 then
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topRightTexture);
				pipe = GetPipe(policy.PolicyBranchType);		
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topLeftTexture);
			else
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(vTexture);
				pipe = GetPipe(policy.PolicyBranchType);		
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topRightTexture);
				pipe = GetPipe(policy.PolicyBranchType);
				pipe.ConnectorImage:SetOffsetVal( xOffset, (policy.GridY-1)*g_PolicyPipeYOffset - 10 );
				pipe.ConnectorImage:SetTexture(topLeftTexture);
			end
		end
	end
	end

	function addbuttons ()
	-- Add Policy buttons
	i = 0;
	--policyInfo = GameInfo.Policies[i];

	for policyInfo in DB.Query("SELECT * FROM Policies") do	

	if policyInfo ~= nil then

		local iBranch = policyInfo.PolicyBranchType;


		if (iBranch ~= nil) then
			local controlTable = nil;

			-- decide which panel it goes on
	if branchType == "POLICY_BRANCH_MANORALISM" then
		controlTable = g_ManoralismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_FEUDALISM" then
		contralTable = g_FeudalismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_MERCANTILISM" then
		contralTable = g_MercantilismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_LAISSEZ_FAIRE" then
		contralTable = g_LaissezFaireInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_CORPORATISM" then
		contralTable = g_CorporatismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_COLLECTIVISM" then
		contralTable = g_CollectivismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_COMMAND_ECONOMY" then
		contralTable = g_CommandEconomyInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_FREE_TRADE" then
		contralTable = g_FreeTradeInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_SOCIALISM" then
		contralTable = g_SocialismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_COMMUNISM" then
		contralTable = g_CommunismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_TRADITION" then
		contralTable = g_TraditionInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_NOBILITY" then
		contralTable = g_NobilityInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_IMPERIALISM" then
		contralTable = g_ImperialismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_LIBERTARIANISM" then
		contralTable = g_LibertarianismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_ANARCHY" then
		contralTable = g_AnarchismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_LIBERTY" then
		contralTable = g_LibertyInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_FREEDOM" then
		contralTable = g_FreedomInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_ENLIGHTENMENT" then
		contralTable = g_EnlightenmentInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_TOP_DOWN_CONTROL" then
		contralTable = g_TopDownInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_DYSTOPIA" then
		contralTable = g_DystopiaInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_EXPANSIONISM" then
		contralTable = g_ExpansionismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_HONOR" then
		contralTable = g_HonorInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_COLONIALISM" then
		contralTable = g_ColonialismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_ISOLATIONISM" then
		contralTable = g_IsolationismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_NATIONALISM" then
		contralTable = g_NationalismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_RESTRAINT" then
		contralTable = g_RestraintInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_SELF_PROTECTION" then
		contralTable = g_SelfProtectionInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_PACIFISM" then
		contralTable = g_PacifismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_GLOBAL_INVOLVEMENT" then
		contralTable = g_GlobalInvolvementInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_TOTAL_WAR" then
		contralTable = g_TotalWarInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_SCIENTIFIC_CONTROL" then
		contralTable = g_ScientificControlInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_PATRONAGE" then
		contralTable = g_PatronageInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_STAGNATION" then
		contralTable = g_StagnationInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_PERSECUTION" then
		contralTable = g_PersecutionInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_RELIGIOUS_RIGHT" then
		contralTable = g_ReligousRightInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_FREE_RESEARCH" then
		contralTable = g_FreeResearchInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_KNOWLEDGE" then
		contralTable = g_KnowledgeInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_RATIONALISM" then
		contralTable = g_RationalismInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_SPONSORSHIP" then
		contralTable = g_SponsorshipInstanceManager:GetInstance();
	elseif iBranch == "POLICY_BRANCH_RADICAL_SCIENCE" then
		contralTable = g_RadicalScienceInstanceManager:GetInstance();
	return controlTable;
	end

			IconHookup( policyInfo.PortraitIndex, 64, policyInfo.IconAtlas, controlTable.PolicyImage );

			-- this math should match Russ's mocked up layout
			controlTable.PolicyIcon:SetOffsetVal((policyInfo.GridX-1)*g_PolicyXOffset+16,(policyInfo.GridY-1)*g_PolicyYOffset+12);
			controlTable.PolicyIcon:SetVoid1( i ); -- indicates which policy
			controlTable.PolicyIcon:RegisterCallback( Mouse.eLClick, PolicySelected );

			-- store this away for later
			policyIcons[i] = controlTable;
		end
	end	
		i = i + 1;
		--policyInfo = GameInfo.Policies[i];
	end

end

function OnYes( )
	Controls.PolicyConfirm:SetHide(true);
	Controls.BGBlock:SetHide(false);

	Network.SendUpdatePolicies(m_gPolicyID, m_gAdoptingPolicy, true);
	Events.AudioPlay2DSound("AS2D_INTERFACE_POLICY");		
	--Game.DoFromUIDiploEvent( FromUIDiploEventTypes.FROM_UI_DIPLO_EVENT_HUMAN_DECLARES_WAR, g_iAIPlayer, 0, 0 );
end
Controls.Yes:RegisterCallback( Mouse.eLClick, OnYes );

function OnNo( )
	Controls.PolicyConfirm:SetHide(true);
	Controls.BGBlock:SetHide(false);
end
Controls.No:RegisterCallback( Mouse.eLClick, OnNo );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
        Controls.PolicyInfo:SetCheck( OptionsManager.GetPolicyInfo() );
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	--OpenAdvisorPopup(ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY);
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);
        else
            UI.decTurnTimerSemaphore();
            --CloseAdvisorPopup(ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY);
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_CHOOSEPOLICY, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

----------------------------------------------------------------
-- 'Active' (local human) player has changed
----------------------------------------------------------------
function OnActivePlayerChanged()
	if (not Controls.PolicyConfirm:IsHidden()) then
		Controls.PolicyConfirm:SetHide(true);
    	Controls.BGBlock:SetHide(false);
	end
	OnClose();
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged);

Init();