-------------------------------------------------
-- Notification Log Popup
-------------------------------------------------
include( "IconSupport" );
include( "InstanceManager" );
include( "TechHelpInclude" );

local g_InfoButtonManager1 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.CavemanButtonStack );
local g_TechPageButtonManager1 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.CavemanButtonStack );

local g_InfoButtonManager2 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.NomadButtonStack );
local g_TechPageButtonManager2 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.NomadButtonStack );

local g_InfoButtonManager3 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.AncientButtonStack );
local g_TechPageButtonManager3 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.AncientButtonStack );

local g_InfoButtonManager4 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.ClassicalButtonStack );
local g_TechPageButtonManager4 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.ClassicalButtonStack );

local g_InfoButtonManager5 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Medieval1ButtonStack );
local g_TechPageButtonManager5 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Medieval1ButtonStack );

local g_InfoButtonManager6 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Medieval2ButtonStack );
local g_TechPageButtonManager6 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Medieval2ButtonStack );

local g_InfoButtonManager7 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.RenaissanceButtonStack );
local g_TechPageButtonManager7 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.RenaissanceButtonStack );

local g_InfoButtonManager8 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Industrial1ButtonStack );
local g_TechPageButtonManager8 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Industrial1ButtonStack );

local g_InfoButtonManager9 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Industrial2ButtonStack );
local g_TechPageButtonManager9 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Industrial2ButtonStack );

local g_InfoButtonManager10 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Industrial3ButtonStack );
local g_TechPageButtonManager10 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Industrial3ButtonStack );

local g_InfoButtonManager11 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.AtomicButtonStack );
local g_TechPageButtonManager11 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.AtomicButtonStack );

local g_InfoButtonManager13 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Modern1ButtonStack );
local g_TechPageButtonManager13 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Modern1ButtonStack );

local g_InfoButtonManager14 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Modern2ButtonStack );
local g_TechPageButtonManager14 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Modern2ButtonStack );

local g_InfoButtonManager15 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.InformationButtonStack );
local g_TechPageButtonManager15 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.InformationButtonStack );

local g_InfoButtonManager16 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Nanotech1ButtonStack );
local g_TechPageButtonManager16 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Nanotech1ButtonStack );

local g_InfoButtonManager17 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Nanotech2ButtonStack );
local g_TechPageButtonManager17 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Nanotech2ButtonStack );

local g_InfoButtonManager18 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Nanotech3ButtonStack );
local g_TechPageButtonManager18 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Nanotech3ButtonStack );

local g_InfoButtonManager19 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Stellar1ButtonStack );
local g_TechPageButtonManager19 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Stellar1ButtonStack );

local g_InfoButtonManager20 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Stellar2ButtonStack );
local g_TechPageButtonManager20 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Stellar2ButtonStack );

local g_InfoButtonManager21 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Stellar3ButtonStack );
local g_TechPageButtonManager21 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Stellar3ButtonStack );

local g_InfoButtonManager22 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Galactic1ButtonStack );
local g_TechPageButtonManager22 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Galactic1ButtonStack );

local g_InfoButtonManager23 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Galactic2ButtonStack );
local g_TechPageButtonManager23 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Galactic2ButtonStack );

local g_InfoButtonManager24 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.Galactic3ButtonStack );
local g_TechPageButtonManager24 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.Galactic3ButtonStack );

local g_InfoButtonManager25 = InstanceManager:new( "InfoButton", "OpenInfo", Controls.UniversalButtonStack );
local g_TechPageButtonManager25 = InstanceManager:new( "TechPageButton", "OpenTechPageButton", Controls.UniversalButtonStack );

local m_PopupInfo = nil;

local Cat1=0;
local ButtonCount=1;
local portraitSize = 128;




-------------------------------------------------
-- On Popup
-------------------------------------------------

function InitialSetup()

	AddCavemanButton( );
	AddNomadButton( );
	AddAncientButton( );
	AddClassicalButton( );
	AddMedieval1Button( );
	AddMedieval2Button( );
	AddRenaissanceButton( );
	AddIndustrial1Button( );
	AddIndustrial2Button( );
	AddIndustrial3Button( );
	AddAtomicButton( );
	AddModern1Button( );
	AddModern2Button( );
	AddInformationButton( );
	AddNanotech1Button( );
	AddNanotech2Button( );
	AddNanotech3Button( );
	AddStellar1Button( );
	AddStellar2Button( );
	AddStellar3Button( );
	AddGalactic1Button( );
	AddGalactic2Button( );
	AddGalactic3Button( );
	AddUniversalButton( );

end

function AddCavemanButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 895
	local xx = -10
	local yy = -10
	while TechPage ~= 898 do
		local controlTable1 = g_InfoButtonManager1:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 895
	xx = 50
	yy = 325
	while TechPage ~= 898 do
		
		local TechPageDesc
		if TechPage == 895 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_HUNTING" );
		elseif TechPage == 896 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_COOKING" );
		elseif TechPage == 897 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_SHELTER" );
		end
		
		local controlTable1 = g_TechPageButtonManager1:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddNomadButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 898
	local xx = -10
	local yy = -10
	while TechPage ~= 901 do
		local controlTable1 = g_InfoButtonManager2:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 901
	xx = 50
	yy = 325
	while TechPage ~= 904 do
		
		local TechPageDesc
		if TechPage == 898 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ANIMAL_HUSBANDRY" );
		elseif TechPage == 899 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_SELECTIVE_BREEDING" );
		elseif TechPage == 900 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_EARTHENWARE" );
		end
		
		local controlTable1 = g_TechPageButtonManager2:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddAncientButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 901
	local xx = -10
	local yy = -10
	while TechPage ~= 904 do
		local controlTable1 = g_InfoButtonManager3:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 901
	xx = 50
	yy = 325
	while TechPage ~= 904 do
		
		local TechPageDesc
		if TechPage == 901 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_AGRICULTURE" );
		elseif TechPage == 902 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_METALWORK" );
		elseif TechPage == 903 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_TRADE" );
		end
		
		local controlTable1 = g_TechPageButtonManager3:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddClassicalButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 904
	local xx = -10
	local yy = -10
	while TechPage ~= 907 do
		local controlTable1 = g_InfoButtonManager4:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 904
	xx = 50
	yy = 325
	while TechPage ~= 907 do
		
		local TechPageDesc
		if TechPage == 904 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ALPHABET" );
		elseif TechPage == 905 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_MATHEMATICS" );
		elseif TechPage == 906 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ENGINEERING" );
		end
		
		local controlTable1 = g_TechPageButtonManager4:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddMedieval1Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 907
	local xx = -10
	local yy = -10
	while TechPage ~= 910 do
		local controlTable1 = g_InfoButtonManager5:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 907
	xx = 50
	yy = 325
	while TechPage ~= 910 do
		
		local TechPageDesc
		if TechPage == 907 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_EDUCATION" );
		elseif TechPage == 908 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ALCHEMY" );
		elseif TechPage == 909 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_BLANK" );
		end
		
		local controlTable1 = g_TechPageButtonManager5:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddMedieval2Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 910
	local xx = -10
	local yy = -10
	while TechPage ~= 913 do
		local controlTable1 = g_InfoButtonManager6:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 910
	xx = 50
	yy = 325
	while TechPage ~= 913 do
		
		local TechPageDesc
		if TechPage == 910 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_SHIPBUILDING" );
		elseif TechPage == 911 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_METALLURGY" );
		elseif TechPage == 912 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_BLANK" );
		end
		
		local controlTable1 = g_TechPageButtonManager6:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddRenaissanceButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 913
	local xx = -10
	local yy = -10
	while TechPage ~= 916 do
		local controlTable1 = g_InfoButtonManager7:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 913
	xx = 50
	yy = 325
	while TechPage ~= 916 do
		
		local TechPageDesc
		if TechPage == 913 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ASTRONOMY" );
		elseif TechPage == 914 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_PHYSICS" );
		elseif TechPage == 915 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_CHEMISTRY" );
		end
		
		local controlTable1 = g_TechPageButtonManager7:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddIndustrial1Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 916
	local xx = -10
	local yy = -10
	while TechPage ~= 919 do
		local controlTable1 = g_InfoButtonManager8:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 916
	xx = 50
	yy = 325
	while TechPage ~= 919 do
		
		local TechPageDesc
		if TechPage == 916 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_STEAM_POWER" );
		elseif TechPage == 917 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_BIOLOGY" );
		elseif TechPage == 918 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_BLANK" );
		end
		
		local controlTable1 = g_TechPageButtonManager8:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddIndustrial2Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 919
	local xx = -10
	local yy = -10
	while TechPage ~= 922 do
		local controlTable1 = g_InfoButtonManager9:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 919
	xx = 50
	yy = 325
	while TechPage ~= 922 do
		
		local TechPageDesc
		if TechPage == 919 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_MEDICINE" );
		elseif TechPage == 920 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ELECTROMAGNETICS" );
		elseif TechPage == 921 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_MODERN_ENGINEERING" );
		end
		
		local controlTable1 = g_TechPageButtonManager9:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddIndustrial3Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 922
	local xx = -10
	local yy = -10
	while TechPage ~= 925 do
		local controlTable1 = g_InfoButtonManager10:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 922
	xx = 50
	yy = 325
	while TechPage ~= 925 do
		
		local TechPageDesc
		if TechPage == 922 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FLIGHT" );
		elseif TechPage == 923 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ANTIBIOTICS" );
		elseif TechPage == 924 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_TELECOMMUNICATIONS" );
		end
		
		local controlTable1 = g_TechPageButtonManager10:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddAtomicButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 925
	local xx = -10
	local yy = -10
	while TechPage ~= 928 do
		local controlTable1 = g_InfoButtonManager11:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 925
	xx = 50
	yy = 325
	while TechPage ~= 928 do
		
		local TechPageDesc
		if TechPage == 925 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_RELATIVITY" );
		elseif TechPage == 926 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_QUANTUM_MECHANICS" );
		elseif TechPage == 927 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_COMPUTING" );
		end
		
		local controlTable1 = g_TechPageButtonManager11:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddModern1Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 928
	local xx = -10
	local yy = -10
	while TechPage ~= 931 do
		local controlTable1 = g_InfoButtonManager12:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 928
	xx = 50
	yy = 325
	while TechPage ~= 931 do
		
		local TechPageDesc
		if TechPage == 928 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NUCLEAR_ENERGY" );
		elseif TechPage == 929 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NUCLEAR_BIOLOGY" );
		elseif TechPage == 930 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_SPACEFLIGHT" );
		end
		
		local controlTable1 = g_TechPageButtonManager12:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddModern2Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 931
	local xx = -10
	local yy = -10
	while TechPage ~= 934 do
		local controlTable1 = g_InfoButtonManager13:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 931
	xx = 50
	yy = 325
	while TechPage ~= 934 do
		
		local TechPageDesc
		if TechPage == 931 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_MICROCHIPS" );
		elseif TechPage == 932 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_LASER" );
		elseif TechPage == 933 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_PARTICLE_PHYSICS" );
		end
		
		local controlTable1 = g_TechPageButtonManager13:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddInformationButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 934
	local xx = -10
	local yy = -10
	while TechPage ~= 937 do
		local controlTable1 = g_InfoButtonManager14:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 934
	xx = 50
	yy = 325
	while TechPage ~= 937 do
		
		local TechPageDesc
		if TechPage == 931 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 932 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 933 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager14:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddNanotech1Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 937
	local xx = -10
	local yy = -10
	while TechPage ~= 940 do
		local controlTable1 = g_InfoButtonManager15:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 937
	xx = 50
	yy = 325
	while TechPage ~= 940 do
		
		local TechPageDesc
		if TechPage == 937 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 938 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 939 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager15:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddNanotech2Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 940
	local xx = -10
	local yy = -10
	while TechPage ~= 943 do
		local controlTable1 = g_InfoButtonManager16:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 940
	xx = 50
	yy = 325
	while TechPage ~= 943 do
		
		local TechPageDesc
		if TechPage == 940 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 941 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 942 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager16:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddNanotech3Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 943
	local xx = -10
	local yy = -10
	while TechPage ~= 946 do
		local controlTable1 = g_InfoButtonManager17:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 943
	xx = 50
	yy = 325
	while TechPage ~= 946 do
		
		local TechPageDesc
		if TechPage == 943 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 944 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 945 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager17:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddNanotech3Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 946
	local xx = -10
	local yy = -10
	while TechPage ~= 949 do
		local controlTable1 = g_InfoButtonManager18:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 946
	xx = 50
	yy = 325
	while TechPage ~= 949 do
		
		local TechPageDesc
		if TechPage == 946 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 947 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 948 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager18:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddStellar1Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 949
	local xx = -10
	local yy = -10
	while TechPage ~= 952 do
		local controlTable1 = g_InfoButtonManager19:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 949
	xx = 50
	yy = 325
	while TechPage ~= 952 do
		
		local TechPageDesc
		if TechPage == 949 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 950 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 951 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager19:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddStellar2Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 952
	local xx = -10
	local yy = -10
	while TechPage ~= 955 do
		local controlTable1 = g_InfoButtonManager20:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 952
	xx = 50
	yy = 325
	while TechPage ~= 955 do
		
		local TechPageDesc
		if TechPage == 952 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 953 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 954 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager20:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddStellar3Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 955
	local xx = -10
	local yy = -10
	while TechPage ~= 958 do
		local controlTable1 = g_InfoButtonManager21:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 955
	xx = 50
	yy = 325
	while TechPage ~= 958 do
		
		local TechPageDesc
		if TechPage == 958 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 959 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 960 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager21:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddGalactic1Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 961
	local xx = -10
	local yy = -10
	while TechPage ~= 964 do
		local controlTable1 = g_InfoButtonManager22:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 961
	xx = 50
	yy = 325
	while TechPage ~= 964 do
		
		local TechPageDesc
		if TechPage == 961 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 962 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 963 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager22:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddGalactic2Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 964
	local xx = -10
	local yy = -10
	while TechPage ~= 967 do
		local controlTable1 = g_InfoButtonManager23:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 964
	xx = 50
	yy = 325
	while TechPage ~= 967 do
		
		local TechPageDesc
		if TechPage == 964 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 965 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 966 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager23:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddGalactic3Button( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 967
	local xx = -10
	local yy = -10
	while TechPage ~= 970 do
		local controlTable1 = g_InfoButtonManager24:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 967
	xx = 50
	yy = 325
	while TechPage ~= 970 do
		
		local TechPageDesc
		if TechPage == 967 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 968 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 969 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager24:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function AddUniversalButton( )	

	--This adds buttons to the right side of the box, Firesforever 15/10/2010
	

	local TechPage = 970
	local xx = -10
	local yy = -10
	while TechPage ~= 973 do
		local controlTable1 = g_InfoButtonManager25:GetInstance();
		controlTable1.OpenInfo:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenInfo:SetVoid2( void );
		
		IconHookup( 33, portraitSize, "TECH_ATLAS_1", controlTable1.Classical1Icon );
	
		controlTable1.OpenInfo:SetToolTipString(TechPage);
		
		controlTable1.OpenInfo:SetOffsetVal( xx,yy );
		
		controlTable1.Classical1Icon:SetHide( false );

		controlTable1.OpenInfo:RegisterCallback( Mouse.eLClick, NotificationSelected );
		xx = xx + 310
		yy = -10
		yy = yy - 118
		TechPage = TechPage + 1
	end
	TechPage = 967
	xx = 50
	yy = 325
	while TechPage ~= 973 do
		
		local TechPageDesc
		if TechPage == 970 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_NEW_LIFE" );
		elseif TechPage == 971 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_ATOM_MANIPULATION" );
		elseif TechPage == 972 then
			TechPageDesc = Locale.ConvertTextKey( "TXT_KEY_CCTP_TECHPAGE_FRINGE_SCIENCE" );
		end
		
		local controlTable1 = g_TechPageButtonManager25:GetInstance();
		controlTable1.OpenTechPageButton:SetVoid1( TechPage ); -- indicates type
		controlTable1.OpenTechPageButton:SetVoid2( void );
	
		controlTable1.OpenTechPageButton:SetToolTipString(TechPageDesc);
		controlTable1.TechText:SetText( TechPageDesc );
		
		controlTable1.OpenTechPageButton:SetOffsetVal( xx,yy );

		controlTable1.OpenTechPageButton:RegisterCallback( Mouse.eLClick, NotificationSelected );
		
		xx = xx + 310
		yy = 325
		yy = yy - 361
		TechPage = TechPage + 1
	end
end

function NotificationSelected (id)
    print (id)
	--The id of the button indicates which technology tree the user wants to view, Firesforever 15/10/2010
		--UIManager:DequeuePopup( ContextPtr );
		Events.SerialEventGameMessagePopup( { Type = ButtonPopupTypes.BUTTONPOPUP_TECH_TREE, Data1=id  } );

	--OnClose();
	--UI.ActivateNotification(id);
end

function OnPopup( popupInfo )

	if popupInfo.Type ~= ButtonPopupTypes.BUTTONPOPUP_TECH_TREE then
		return;
	end

	if (popupInfo.Data1 > 900) then
		return;
	end

	-- Set Civ Icon
	CivIconHookup( Game.GetActivePlayer(), 64, Controls.CivIcon, Controls.CivIconBG, Controls.CivIconShadow, false, true );
	
	m_PopupInfo = popupInfo;

	--InitialSetup();

	if( m_PopupInfo.Data1 == 1 ) then
    	if( ContextPtr:IsHidden() == false ) then
    	    OnClose();
        else
        	UIManager:QueuePopup( ContextPtr, PopupPriority.eUtmost );
    	end
	else
    	UIManager:QueuePopup( ContextPtr, PopupPriority.NotificationLog );
	end
end
Events.SerialEventGameMessagePopup.Add( OnPopup );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-- Complete with new OnEraTechs( ) functions!
function OnCavemanTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(false);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(false);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	Controls.EraSelectHighlight:SetHide(true);
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(false);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(false);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraCaveman:RegisterCallback( Mouse.eLClick, OnCavemanTechs );

function OnNomadTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(false);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(false);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	;
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(false);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(false);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraNomad:RegisterCallback( Mouse.eLClick, OnNomadTechs );

function OnAncientTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(false);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(false);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraAncient:RegisterCallback( Mouse.eLClick, OnAncientTechs );

function OnClassicalTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(false);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(false);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(false);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(false);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraClassical:RegisterCallback( Mouse.eLClick, OnClassicalTechs );

function OnMedieval1Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(false);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(false);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(false);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraMedieval1:RegisterCallback( Mouse.eLClick, OnMedieval1Techs );

function OnMedieval2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(false);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(false);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraMedieval2:RegisterCallback( Mouse.eLClick, OnMedieval2Techs );

function OnMedieval2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(false);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(false);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraMedieval2:RegisterCallback( Mouse.eLClick, OnMedieval2Techs );

function OnRenaissanceTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(false);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(false);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraRenaissance:RegisterCallback( Mouse.eLClick, OnRenaissanceTechs );

function OnIndustrial1Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(false);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(false);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraIndustrial1:RegisterCallback( Mouse.eLClick, OnIndustrial1Techs );

function OnIndustrial2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(false);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(false);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraIndustrial2:RegisterCallback( Mouse.eLClick, OnIndustrial2Techs );

function OnIndustrial3Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(false);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(false);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraIndustrial3:RegisterCallback( Mouse.eLClick, OnIndustrial3Techs );

function OnAtomicTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(false);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(false);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraAtomic:RegisterCallback( Mouse.eLClick, OnAtomicTechs );

function OnModern1Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(false);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(false);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraModern1:RegisterCallback( Mouse.eLClick, OnModern1Techs );

function OnModern2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(false);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(false);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraModern2:RegisterCallback( Mouse.eLClick, OnModern2Techs );

function OnInformationTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(false);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(false);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraInformation:RegisterCallback( Mouse.eLClick, OnInformationTechs );

function OnNanotech1Techs( )

	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(false);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(false);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraNanotech1:RegisterCallback( Mouse.eLClick, OnNanotech1Techs );

function OnNanotech2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(false);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(false);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraNanotech2:RegisterCallback( Mouse.eLClick, OnNanotech2Techs );

function OnNanotech3Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(false);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(false);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(false);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraNanotech3:RegisterCallback( Mouse.eLClick, OnNanotech3Techs );

function OnStellar1Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(false);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(false);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraStellar1:RegisterCallback( Mouse.eLClick, OnStellar1Techs );

function OnStellar2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(false);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(false);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraStellar2:RegisterCallback( Mouse.eLClick, OnStellar2Techs );

function OnStellar3Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(false);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(false);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraStellar3:RegisterCallback( Mouse.eLClick, OnStellar3Techs );

function OnGalactic1Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(false);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(false);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraGalactic1:RegisterCallback( Mouse.eLClick, OnGalactic1Techs );

function OnGalactic2Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(false);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(false);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(false);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraGalactic2:RegisterCallback( Mouse.eLClick, OnGalactic2Techs );

function OnGalactic3Techs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(false);
	Controls.EraUniversalSelectHighlight:SetHide(true);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(false);
	Controls.EraUniversalScrollPanel:SetHide(true);

end
Controls.EraGalactic3:RegisterCallback( Mouse.eLClick, OnGalactic3Techs );

function OnUniversalTechs( )

	Controls.EraCavemanSelectHighlight:SetHide(true);
	Controls.EraNomadSelectHighlight:SetHide(true);
	Controls.EraAncientSelectHighlight:SetHide(true);
	Controls.EraClassicalSelectHighlight:SetHide(true);
	Controls.EraMedieval1SelectHighlight:SetHide(true);
	Controls.EraMedieval2SelectHighlight:SetHide(true);
	Controls.EraRenaissanceSelectHighlight:SetHide(true);
	Controls.EraIndustrial1SelectHighlight:SetHide(true);
	Controls.EraIndustrial2SelectHighlight:SetHide(true);
	Controls.EraIndustrial3SelectHighlight:SetHide(true);
	Controls.EraAtomicSelectHighlight:SetHide(true);
	Controls.EraModern1SelectHighlight:SetHide(true);
	Controls.EraModern2SelectHighlight:SetHide(true);
	 
	Controls.EraInformationSelectHighlight:SetHide(true);
	Controls.EraNanotech1SelectHighlight:SetHide(true);
	Controls.EraNanotech2SelectHighlight:SetHide(true);
	Controls.EraNanotech3SelectHighlight:SetHide(true);
	Controls.EraStellar1SelectHighlight:SetHide(true);
	Controls.EraStellar2SelectHighlight:SetHide(true);
	Controls.EraStellar3SelectHighlight:SetHide(true);
	Controls.EraGalactic1SelectHighlight:SetHide(true);
	Controls.EraGalactic2SelectHighlight:SetHide(true);
	Controls.EraGalactic3SelectHighlight:SetHide(true);
	Controls.EraUniversalSelectHighlight:SetHide(false);

	-- Show the selected policies and hide the rest
	Controls.EraCavemanScrollPanel:SetHide(true);
	Controls.EraNomadScrollPanel:SetHide(true);
	Controls.EraAncientScrollPanel:SetHide(true);
	Controls.EraClassicalScrollPanel:SetHide(true);
	Controls.EraMedieval1ScrollPanel:SetHide(true);
	Controls.EraMedieval2ScrollPanel:SetHide(true);
	Controls.EraRenaissanceScrollPanel:SetHide(true);
	Controls.EraIndustrial1ScrollPanel:SetHide(true);
	Controls.EraIndustrial2ScrollPanel:SetHide(true);
	Controls.EraIndustrial3ScrollPanel:SetHide(true);
	Controls.EraAtomicScrollPanel:SetHide(true);
	Controls.EraModern1ScrollPanel:SetHide(true);
	Controls.EraModern2ScrollPanel:SetHide(true);
	Controls.EraModern3ScrollPanel:SetHide(true);
	Controls.EraInformationScrollPanel:SetHide(true);
	Controls.EraNanotech1ScrollPanel:SetHide(true);
	Controls.EraNanotech2ScrollPanel:SetHide(true);
	Controls.EraNanotech3ScrollPanel:SetHide(true);
	Controls.EraStellar1ScrollPanel:SetHide(true);
	Controls.EraStellar2ScrollPanel:SetHide(true);
	Controls.EraStellar3ScrollPanel:SetHide(true);
	Controls.EraGalactic1ScrollPanel:SetHide(true);
	Controls.EraGalactic2ScrollPanel:SetHide(true);
	Controls.EraGalactic3ScrollPanel:SetHide(true);
	Controls.EraUniversalScrollPanel:SetHide(false);

end
Controls.EraUniversal:RegisterCallback( Mouse.eLClick, OnUniversalTechs );
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function OnClose ()
	UIManager:DequeuePopup( ContextPtr );
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
           -- OnClose();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function ShowHideHandler( bIsHide, bInitState )

    if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);
        else
            UI.decTurnTimerSemaphore();
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_NOTIFICATION_LOG, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );


--This code only needs to be done once, Firesforever 14/10/2010
InitialSetup()
